/*
 * FreeAccess Plus! extension (based on "Access Flickr!" extension by Hamed Saber)
 * Version 1.0.5
 * Copyright (C) 2007-8 Mohammad R.M. <mohammad.rmu@gmail.com>
*/

var exchangeSource	= new Array(
	/^([^\.]*\.?)farm3.static.flickr.com$/i,
	/^([^\.]*\.?)farm2.static.flickr.com$/i,
	/^([^\.]*\.?)farm1.static.flickr.com$/i,
	/^([^\.]*\.?)farm(\d).static.flickr.com$/i,
	/^([^\.]*\.?)static.flickr.com$/i,
	/^([^\.]*\.?)blog.flickr.com$/i,
	/^([^\.]*\.?)flickr.com$/i,
	/^([^\.]*\.?)del.icio.us$/i,
	/^([^\.]*\.?)zigzagmag.com$/i,
	/^([^\.]*\.?)technorati.com$/i,
	/^([^\.]*\.?)img.youtube.com$/i,
	/^([^\.]*\.?)static.youtube.com$/i,
	/^([^\.]*\.?)youtube.com$/i,
	/^([^\.]*\.?)newsimg.bbc.co.uk$/i,
	/^([^\.]*\.?)bbc.co.uk$/i,
	/^([^\.]*\.?)i13.tinypic.com$/i,
	/^([^\.]*\.?)i12.tinypic.com$/i,
	/^([^\.]*\.?)i11.tinypic.com$/i,
	/^([^\.]*\.?)i10.tinypic.com$/i,
	/^([^\.]*\.?)i9.tinypic.com$/i,
	/^([^\.]*\.?)i8.tinypic.com$/i,
	/^([^\.]*\.?)i7.tinypic.com$/i,
	/^([^\.]*\.?)i6.tinypic.com$/i,
	/^([^\.]*\.?)i5.tinypic.com$/i,
	/^([^\.]*\.?)i4.tinypic.com$/i,
	/^([^\.]*\.?)i3.tinypic.com$/i,
	/^([^\.]*\.?)i2.tinypic.com$/i,
	/^([^\.]*\.?)i1.tinypic.com$/i,
	/^([^\.]*\.?)torrentspy.com$/i,
	/^([^\.]*\.?)www.friendster.com$/i,
	/^([^\.]*\.?)www.livejournal.com$/i,
	/^([^\.]*\.?)sobhaneh.org$/i,
	/^([^\.]*\.?)news.gooya.com$/i,
	/^([^\.]*\.?)go.com$/i,
	/^([^\.]*\.?)hi5.com$/i,
	/^([^\.]*\.?)myspace.com$/i,
	/^([^\.]*\.?)sarzamin.org$/i
	);
var exchangeDest = new Array(
	'farm3.static.flickr.yahoo3.akadns.net',
	'farm2.static.flickr.yahoo3.akadns.net',
	'farm1.static.flickr.yahoo3.akadns.net',
	'farm$2.static.flickr.yahoo3.akadns.net',
	'68.142.232.116',
	'blog.flickr.com',
	'flickr.mud.yahoo.com',
	'69.147.76.140',
	unescape('%38%30%2E%37%31%2E%33%2E%31%38%38'),
	unescape('%32%30%38%2E%36%36%2E%36%34%2E%31%33%32'),
	unescape('%69%6D%67%2E%79%6F%75%74%75%62%65%2E%63%6F%6D'),
	unescape('%37%34%2E%31%32%35%2E%31%30%2E%31%30%30'),
	unescape('%32%30%38%2E%36%35%2E%31%35%33%2E%32%33%38'),
	unescape('%6E%65%77%73%69%6D%67%2E%62%62%63%2E%63%6F%2E%75%6B'),
	unescape('%32%31%32%2E%35%38%2E%32%32%34%2E%38%33'),
	unescape('%32%30%39%2E%31%37%2E%36%38%2E%37%30'),
	unescape('%32%30%39%2E%31%37%2E%36%38%2E%33%35'),
	unescape('%32%30%39%2E%31%37%2E%36%38%2E%33%36'),
	unescape('%32%30%39%2E%31%37%2E%36%38%2E%36%39'),
	unescape('%32%30%39%2E%31%37%2E%36%38%2E%36%38'),
	unescape('%32%30%39%2E%31%37%2E%36%38%2E%34%32'),
	unescape('%32%30%39%2E%31%37%2E%36%38%2E%34%32'),
	unescape('%32%30%39%2E%31%37%2E%36%38%2E%37%33'),
	unescape('%32%30%39%2E%31%37%2E%36%38%2E%37%33'),
	unescape('%32%30%39%2E%31%37%2E%36%38%2E%34%31'),
	unescape('%32%30%39%2E%31%37%2E%36%38%2E%34%31'),
	unescape('%32%30%39%2E%31%37%2E%36%38%2E%37%32'),
	unescape('%32%30%39%2E%31%37%2E%36%38%2E%37%32'),
	unescape('%38%37%2E%32%33%33%2E%31%36%37%2E%31%34%30'),
	unescape('%32%30%39%2E%31%31%2E%31%36%38%2E%31%31%32'),
	unescape('%32%30%34%2E%39%2E%31%37%37%2E%31%38'),
	unescape('%38%37%2E%31%30%36%2E%39%37%2E%32%33%33'),
	unescape('%37%30%2E%38%36%2E%32%32%2E%39%39'),
	unescape('%31%39%38%2E%31%30%35%2E%31%39%33%2E%37%30'),
	unescape('%32%30%34%2E%31%33%2E%35%31%2E%31%39%36'),
	unescape('%32%31%36%2E%31%37%38%2E%33%38%2E%31%31%36'),
	unescape('%36%31%2E%31%35%32%2E%39%35%2E%31%37%31')
	);


function flickrObserver() {
  this.register();
}

flickrObserver.prototype = {
  observe: function(subject, topic, data)  {
    if (topic == "http-on-modify-request") {
      var httpChannel = subject.QueryInterface(Components.interfaces.nsIHttpChannel);
      var host = httpChannel.getRequestHeader("host");
      for (var i=0; i < exchangeSource.length; i++) {
        if (exchangeSource[i].test(host)) {
          httpChannel.setRequestHeader("host", exchangeDest[i], false);
		  break;
        }
      }
    } else if (topic == "http-on-examine-response") {
      var httpChannel = subject.QueryInterface(Components.interfaces.nsIHttpChannel);
      try {
      	var cookies = httpChannel.getResponseHeader("Set-Cookie");
      	if (cookies) {
      	  while ((cookieArray = /[^\n]+/igm.exec(cookies)) != undefined) {
      	    var cookie = cookieArray[0];
      	    if (/domain=flickr\.mud\.yahoo\.com/i.test(cookie)) {
      	      cookie = cookie.replace(/^(.+)?\.mud\.yahoo(.+)?$/i, "$1$2");
      	      httpChannel.setResponseHeader("Set-Cookie", cookie, true);
      	    }
      	  }
      	}
      } catch (e) {}
    }
  },

  get observerService() {
    return Components.classes["@mozilla.org/observer-service;1"]
                     .getService(Components.interfaces.nsIObserverService);
  },
  register: function() {
    this.observerService.addObserver(this, "http-on-modify-request", false);
    this.observerService.addObserver(this, "http-on-examine-response", false);
  },
  unregister: function() {
    this.observerService.removeObserver(this, "http-on-modify-request");
  }
};

window.addEventListener("load", function() {
  var observer = new flickrObserver();
  window.addEventListener("unload", function() {
    observer.unregister();
  }, false);
}, false);